import { ReactNode, ReactElement, ComponentProps } from 'react';

type TabItem = string | ReactNode;
type TabObjectItem = {
    label: TabItem;
    disabled: boolean;
};
declare function Tabs({ items, selectedIndex: _selectedIndex, defaultIndex, onChange, children, storageKey }: {
    items: (TabItem | TabObjectItem)[];
    selectedIndex?: number;
    defaultIndex?: number;
    onChange?: (index: number) => void;
    children: ReactNode;
    storageKey?: string;
}): ReactElement;
declare function Tab({ children, ...props }: ComponentProps<'div'>): ReactElement;

export { Tab, Tabs };
